#  赛道修建

## 题目描述

C 城将要举办一系列的赛车比赛。在比赛前，需要在城内修建 $m$ 条赛道。 

C 城一共有 $n$ 个路口，这些路口编号为 $1,2,…,n$，有 $n-1$ 条适合于修建赛道的双向通行的道路，每条道路连接着两个路口。其中，第 $i$ 条道路连接的两个路口编号为 $a_i$ 和 $b_i$，该道路的长度为 $l_i$。借助这 $n-1$ 条道路，从任何一个路口出发都能到达其他所有的路口。 

一条赛道是一组互不相同的道路 $e_1,e_2,…,e_k$，满足可以从某个路口出发，依次经过 道路 $e_1,e_2,…,e_k$（每条道路经过一次，不允许调头）到达另一个路口。一条赛道的长度等于经过的各道路的长度之和。为保证安全，要求每条道路至多被一条赛道经过。 

目前赛道修建的方案尚未确定。你的任务是设计一种赛道修建的方案，使得修建的 $m$ 条赛道中长度最小的赛道长度最大（即 $m$ 条赛道中最短赛道的长度尽可能大）

## 输入格式

输入文件第一行包含两个由空格分隔的正整数 $n,m$，分别表示路口数及需要修建的 赛道数。 

接下来 $n-1$ 行，第 $i$ 行包含三个正整数 $a_i,b_i,l_i$，表示第 $i$ 条适合于修建赛道的道 路连接的两个路口编号及道路长度。保证任意两个路口均可通过这 $n-1$ 条道路相互到达。每行中相邻两数之间均由一个空格分隔。

## 输出格式

输出共一行，包含一个整数，表示长度最小的赛道长度的最大值。

## 样例 #1

### 样例输入 #1

```
7 1 
1 2 10 
1 3 5 
2 4 9 
2 5 8 
3 6 6 
3 7 7
```

### 样例输出 #1

```
31
```

## 样例 #2

### 样例输入 #2

```
9 3 
1 2 6 
2 3 3 
3 4 5 
4 5 10 
6 2 4 
7 2 9 
8 4 7 
9 4 4
```

### 样例输出 #2

```
15
```

## 提示

【输入输出样例 1 说明】 

所有路口及适合于修建赛道的道路如下图所示：      

![](https://cdn.luogu.com.cn/upload/image_hosting/bkj3pfqm.png)

道路旁括号内的数字表示道路的编号，非括号内的数字表示道路长度。 需要修建 $1$ 条赛道。可以修建经过第 $3,1,2,6$ 条道路的赛道（从路口 $4$ 到路口 $7$）， 则该赛道的长度为 $9 + 10 + 5 + 7 = 31$，为所有方案中的最大值。

【输入输出样例 2 说明】

 所有路口及适合于修建赛道的道路如下图所示：   
  

![](https://cdn.luogu.com.cn/upload/image_hosting/e9lcljwr.png)

需要修建 $3$ 条赛道。可以修建如下 $3$ 条赛道： 
1. 经过第 $1,6 $条道路的赛道（从路口 $1$ 到路口$ 7$），长度为 $6 + 9 = 15$； 
2. 经过第$ 5,2,3,8$ 条道路的赛道（从路口$ 6$ 到路口 $9$），长度为 $4 + 3 + 5 + 4 = 16$；
3. 经过第 $7,4$ 条道路的赛道（从路口 $8$ 到路口$ 5$），长度为 $7 + 10 = 17$。 长度最小的赛道长度为 $15$，为所有方案中的最大值。 

### 数据规模与约定

所有测试数据的范围和特点如下表所示 :

| 测试点编号 | $n$ | $m$ | $a_i=1$ | $b_i=a_i+1$ | 分支不超过 $3$ |
|:-:|:-:|:-:|:-:|:-:|:-:|
| $1$ | $\le 5$ | $=1$ | 否 | 否 | 是 |
| $2$ | $\le 10$ | $\le n-1$ | 否 | 是 | 是 |
| $3$ | $\le 15$ | $\le n-1$ | 是 | 否 | 否 |
| $4$ | $\le 10^3$ | $=1$ | 否 | 否 | 是 |
| $5$ | $\le 3\times 10^4$ | $=1$ | 是 | 否 | 否 |
| $6$ | $\le 3\times 10^4$ | $=1$ | 否 | 否 | 否 |
| $7$ | $\le 3\times 10^4$ | $\le n-1$ | 是 | 否 | 否 |
| $8$ | $\le 5\times 10^4$ | $\le n-1$ | 是 | 否 | 否 |
| $9$ | $\le 10^3$ | $\le n-1$ | 否 | 是 | 是 |
| $10$ | $\le 3\times 10^4$ | $\le n-1$ | 否 | 是 | 是 |
| $11$ | $\le 5\times 10^4$ | $\le n-1$ | 否 | 是 | 是 |
| $12$ | $\le 50$ | $\le n-1$ | 否 | 否 | 是 |
| $13$ | $\le 50$ | $\le n-1$ | 否 | 否 | 是 |
| $14$ | $\le 200$ | $\le n-1$ | 否 | 否 | 是 |
| $15$ | $\le 200$ | $\le n-1$ | 否 | 否 | 是 |
| $16$ | $\le 10^3$ | $\le n-1$ | 否 | 否 | 是 |
| $17$ | $\le 10^3$ | $\le n-1$ | 否 | 否 | 否 |
| $18$ | $\le 3\times 10^4$ | $\le n-1$ | 否 | 否 | 否 |
| $19$ | $\le 3\times 10^4$ | $\le n-1$ | 否 | 否 | 否 |
| $20$ | $\le 5\times 10^4$ | $\le n-1$ | 否 | 否 | 否 |

其中，「分支不超过 $3$」的含义为：每个路口至多有 $3$ 条道路与其相连。

对于所有的数据，$2 \le n \le 5\times 10^4, \ 1 \le m \le n − 1,\ 1 \le a_i,b_i \le n,\  1 \le l_i \le 10^4$。